%{!?__python2: %global __python2 /usr/bin/python2}
%{!?python2_sitelib: %global python2_sitelib %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print (get_python_lib())")}
%{!?py2_build: %global py2_build() %{__python2} setup.py build --executable="%{__python2} -s"}
%{!?py2_install: %global py2_install() %{__python2} setup.py install -O1 --skip-build --root %{buildroot}}
%{!?python_provide: %global python_provide Provides:       python-%{pkgname} = %{version}-%{release}}

%global srcname osrf_pycommon
%global pkgname osrf-pycommon
%global sum Commonly needed Python modules used by software developed at OSRF

Name:           python-%{pkgname}
Version:        0.1.2
Release:        1%{?dist}
Summary:        %{sum}

Group:          Development/Libraries
# The entire source code is ASL 2.0 except parts of osrf_pycommon/terminal_color/windows.py which is BSD
License:        ASL 2.0 and BSD
URL:            http://osrf-pycommon.readthedocs.org/
Source0:        https://github.com/osrf/%{srcname}/archive/%{version}.tar.gz#/%{srcname}-%{version}.tar.gz

BuildArch:      noarch

%description
osrf_pycommon is a python package which contains commonly used Python
boilerplate code and patterns. Things like ANSI terminal coloring, capturing
colored output from programs using sub-process, or even a simple logging system
which provides some nice functionality over the built-in Python logging system.

The functionality provided here should be generic enough to be reused in
arbitrary scenarios and should avoid bringing in dependencies which are not
part of the standard Python library. Where possible Windows and Linux/OS X
should be supported, and where it cannot it should be gracefully degrading.

%package doc
Summary:        API Documentation for the osrf_pycommon Python modules
%if 0%{?rhel} && 0%{?rhel} < 7
BuildRequires:  python-sphinx10
%else
BuildRequires:  python-sphinx
%endif

%description doc
HTML documentation generated from osrf_pycommon sources to be used in
developing software which uses osrf_pycommon.

%package -n python2-%{pkgname}
Summary:        %{sum}
BuildRequires:  python2-devel
%if !(0%{?rhel} && 0%{?rhel} < 7)
BuildRequires:  python-flake8
%endif
BuildRequires:  python-mock
BuildRequires:  python-nose
BuildRequires:  python-setuptools
BuildRequires:  python-trollius
Requires:       python-trollius
%{?python_provide:%python_provide python2-%{pkgname}}

%description -n python2-%{pkgname}
osrf_pycommon is a python package which contains commonly used Python
boilerplate code and patterns. Things like ANSI terminal coloring, capturing
colored output from programs using sub-process, or even a simple logging system
which provides some nice functionality over the built-in Python logging system.

The functionality provided here should be generic enough to be reused in
arbitrary scenarios and should avoid bringing in dependencies which are not
part of the standard Python library. Where possible Windows and Linux/OS X
should be supported, and where it cannot it should be gracefully degrading.

%prep
%autosetup -n %{srcname}-%{version}

%build
%py2_build

%if 0%{?rhel} && 0%{?rhel} < 7
make -C docs html man SPHINXBUILD=sphinx-1.0-build
%else
make -C docs html man
%endif
rm docs/_build/html/.buildinfo

%install
%py2_install

install -p -m0644 -D docs/_build/man/%{srcname}.1 %{buildroot}%{_mandir}/man1/%{srcname}.1
rm -rf %{buildroot}%{python2_sitelib}/%{srcname}/process_utils/async_execute_process_asyncio

%check
PYTHONASYNCIODEBUG=1 nosetests -w tests \
%if 0%{?rhel} && 0%{?rhel} < 7
  -e test_code_format.py \
  -e test_async_execute_process.py \
  -e test_execute_process_pty.py \
  -e test_call_prepare_arguments \
%endif
  %{nil}

%files doc
%doc docs/_build/html
%license LICENSE

%files -n python2-%{pkgname}
%doc CHANGELOG.rst README.md
%license LICENSE
%{_mandir}/man1/%{srcname}.1.gz
%{python2_sitelib}/%{srcname}/
%{python2_sitelib}/%{srcname}-%{version}-py?.?.egg-info/

%changelog
* Mon Apr 18 2016 Scott K Logan <logans@cottsay.net> - 0.1.2-1
- Initial package
